/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2004-2011 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/********************************************************************************/
/*                                                                              */
/*                                  Pio (C++)                                   */
/*                                                                              */
/*                        Polyglot Input/Output Library                         */
/*                                                                              */
/*                      projet Estime, INRIA-Rocquencourt                       */
/*                                                                              */
/*  Copyright 2004-2011 INRIA.                                                  */
/*  Institut National de Recherche en Informatique et en Automatique.           */
/*  All rights reserved. This file is distributed only by permission.           */
/*                                                                              */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                                */
/*                                                                              */
/********************************************************************************/

/***********************************************************************/
/*                                                                     */
/*                              Io (C++)                               */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2005-2006 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: boolean.cpp,v 1.3 2011-02-23 17:43:29 fclement Exp $ */

#include<iostream>

#include "boolean.hpp"

using namespace std;
using namespace io;

void operator >> (istream& ic,boolean& b){
  char fivechar[6], c;
  EndOfStream k;
  SyntaxError t; 
  
  for (int i=0; i<4; i++) {
    fivechar[i] = ' ';
  }
  fivechar[4] = fivechar[5] = 0;
  
  ic.get(c);
  if (c != '\n') {
    fivechar[0] = c;
  } else {
    ic.get(fivechar[0]);
  }
  
  for (int i=1; i<4; i++) {
    if(ic.eof()) {
      throw(k);
    }
    ic.get(fivechar[i]);
  }
  string s(fivechar);
  if (s == "true") {
    b.set_value(true);
  } else if (s == "fals") {
    if(ic.eof()) {
      throw(k);
    }
    ic.get(fivechar[4]);
    if (fivechar[4] == 'e') {
      b.set_value(false);
    } else {
      cerr<<"syntax error in operator >>: \""<<s<<"\" is neither \"true\" nor \"false\"."<<endl;
      throw(t);
    }
  } else {
    cerr<<"syntax error in operator >>: \""<<s<<"\" is neither \"true\" nor \"false\"."<<endl;
    throw(t);
  }
}

std::ostream& operator << (ostream& oc,boolean& b){
  oc<<b.get_value();
  return oc;
}
