(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                  projet Estime, INRIA-Rocquencourt                  *)
(*                                                                     *)
(*  Copyright 2007-2011 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux <Quentin.Carbonneaux@inria.fr>                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: tio.mli,v 1.5.2.1 2011-09-21 13:08:04 fclement Exp $ *)

type tic;;

type 'a tio =
  | Line of 'a
  | Eof
  | Timeout
;;

exception Tio_error of string;;

val tic_of_in_channel : in_channel -> tic;;
val input : tic -> string -> int -> int -> int -> int tio;;
val input_char : tic -> int -> char tio;;
val input_line : tic -> int -> string tio;;
